function [sigmastar,value]=fittedsigma
% Ex 6-3b) find the optimal sigma_* which minimizes the L^2 error of
% observed ATM cap price  and calibrated Vasicek bond price

% lower bound for sigma_*
tol=10^(-3);

% find the minimal value
[sigmastar,value]= fminbnd(@(sigma) temp(sigma),tol,1);
end


function [error]=temp(sigma)
%parameters
b=0.0774;
beta=-0.86;
r0=0.08;

% observed ATM cap prices
P = [0.00215686,0.00567477,0.00907115,0.0121906,0.01503,0.017613,0.0199647,0.0221081,0.025847,0.028963,0.0326962,0.0370565,0.0416089];
% associated maturities
T =[1,2,3,4,5,6,7,8,10,12,15,20,30];

CVA= zeros(1,length(P));
for i=1:length(P)
    % computed ATM cap price
CVA(i) = capvasicekatm(b,beta,sigma,r0,1/4,1/4,T(i));
end

% L^2 norm of the error
error = sum((CVA-P).^2);
end